<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

include("include/connection.php");
include("adminlogs/admin_logs.php");
include("notification/client_notification.php");
include("jwtvalidation/jwt_validation.php");
require 'secret_key.php';
include("sendemail/sendMail.php");
include("allmails/allMail.php");


try {
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
        throw new Exception('Invalid request method');
    }

    $headers = apache_request_headers();
    $secretKey = $secret_Key;
    $decodedToken = validateJWT($headers, $secretKey);

    $userId = $decodedToken['user_id'];

    // Assuming your JSON data is sent in the request body
    $json_data = file_get_contents('php://input');

    // Decode the JSON data
    $data = json_decode($json_data, true);

    $id = isset($data['id']) ? mysqli_real_escape_string($conn, $data['id']) : null;
    $transCost = isset($data['transcost']) ? mysqli_real_escape_string($conn, $data['transcost']) : '';
    $promoCost = isset($data['promocost']) ? mysqli_real_escape_string($conn, $data['promocost']) : '';
    $adminId = isset($data['adminId']) ? mysqli_real_escape_string($conn, $data['adminId']) : null;

    // Select the client 
    $selectQuery = "SELECT * FROM clients WHERE `c_id` = '$id'";
    $selectResult = mysqli_query($conn, $selectQuery);

    $row_count = mysqli_num_rows($selectResult);
    if ($row_count < 1) {
        throw new Exception('Client not found');
    }

    $client_data = mysqli_fetch_assoc($selectResult);

    $c_mail = $client_data["email"];
    $client_name = $client_data["f_name"] . " " . $client_data["l_name"];

    //select senderid
    $senderQuery = "SELECT trans_per_msg, promo_per_msg FROM sender_details WHERE `client_id` = '$id'";
    $senderResult = mysqli_query($conn, $senderQuery);

    $sender_count = mysqli_num_rows($senderResult);

    if ($sender_count < 1) {
        throw new Exception('No sender id found');
    }

    // Fetch the first row of data
    $sender_data = mysqli_fetch_assoc($senderResult);  // This returns an associative array of the first row

    // Now you can access trans_per_msg and promo_per_msg directly from the array
    $trans_per_msg = $sender_data['trans_per_msg'];
    $promo_per_msg = $sender_data['promo_per_msg'];

    // Update trans_per_msg and promocost in clients table
    $updateClientQuery = "UPDATE clients SET `trans_per_msg` = '$transCost', `promo_per_msg` = '$promoCost' WHERE `c_id` = '$id'";
    $updateClientResult = mysqli_query($conn, $updateClientQuery);

    $updateSenderQuery = "UPDATE sender_details SET `trans_per_msg` = '$transCost', `promo_per_msg` = '$promoCost' WHERE `client_id` = '$id'";
    $updateSenderResult = mysqli_query($conn, $updateSenderQuery);


    if ($updateClientResult && $updateSenderQuery) {

        $query_system = "SELECT * FROM system_setting";

        $result_system = mysqli_query($conn, $query_system);

        if (mysqli_num_rows($result_system) > 0) {
            $row_system = mysqli_fetch_assoc($result_system);
            //pass row-system to email

            $mailCont = promotransCost($row_system, $client_name, $c_mail, $trans_per_msg, $promo_per_msg, $transCost, $promoCost);

            $postFileds = [
                'to' => $c_mail, // Recipient's email address
                'sub' => 'Transaction and Promotional Cost Update', // Email subject
                'msg' => $mailCont, // HTML content of the email
                'from' => $row_system['email_api_vender_email']  // Sender's email address billing@ozonesender.com For Billing , hello@ozonesender.com For General
            ];

            $sms_details = sendMail($postFileds);

            $sms_details_array = json_decode($sms_details, true);

            $response = array('success' => true, 'message' => 'promo and trans cost updated successfully');

            // admin login
            $by = $userId;
            $date = date('Y-m-d H:i:s');
            $module = 'update promo and trans cost';
            $message = "Administrator $userId has successfully updated the update promo and trans cost for Client $id.";

            insertAdminLog($conn, $by, $date, $module, $message);

            // notification
            $title = 'Update Promo and trans cost';
            $date = date('Y-m-d H:i:s');
            $subtitle = "Updated the transactional cost to $transCost and the promotional cost to $promoCost.";
            $avatar = 'PT';
            $client_id = $id;

            insertNotification($conn, $title, $date, $subtitle, $avatar, $client_id);
        } else {
            throw new Exception("system data not found");
        }
    } else {
        $response = array('success' => false, 'message' => 'Failed to update promo and trans cost');
    }

    echo json_encode($response);
} catch (Exception $e) {
    $response = array('success' => false, 'message' => $e->getMessage());
    echo json_encode($response);
}
